local floor, ceil, sqrt = math.floor, math.ceil, math.sqrt

local basic = data.raw.inserter["basic-inserter"]
local bburn = data.raw.inserter["burner-inserter"]

local metric = {["k"]=3,["M"]=6,["G"]=9,["T"]=12,["P"]=15,}
function getenergy(str)
	if not str then return nil end
	local num, magnitude = tonumber(string.sub(str,1,-3)),string.sub(str,-2,-2)
	num = num * 10^(metric[magnitude] or 0)
	return num
end

function get_moment(inserter)

	local c, sum = {}, 0
	c[1],c[2] = unpack(inserter.pickup_position)
	c[3],c[4] = unpack(inserter.insert_position)
	for k,v in pairs(c) do
		if v>0 then sum = sum + floor(v)^2 else sum = sum + ceil(v)^2 end
	end
	
	return sum/2
end

local basicmom = get_moment(basic)
local bburnmom = get_moment(bburn)

--local log={}
local base,moment

for name,inserter in pairs(data.raw.inserter) do
--	table.insert(log,name..get_moment(inserter))
	if name ~= "basic-inserter" and name ~= "burner-inserter" then
		if inserter.energy_source.type=="electric" then base,moment=basic,basicmom else base,moment=bburn,bburnmom end
		if inserter.programmable then
			--inserter.energy_source.drain = "4kW"
			inserter.energy_source.drain = (10 * getenergy(inserter.energy_source.drain)).."W"
			inserter.energy_per_rotation = base.energy_per_rotation
			inserter.energy_per_movement = base.energy_per_movement
		end
		
		inserter.energy_per_rotation = base.energy_per_rotation * get_moment(inserter)/moment * inserter.rotation_speed/base.rotation_speed
		inserter.energy_per_movement = base.energy_per_movement * inserter.extension_speed/base.extension_speed
		
--		table.insert(log,serpent.block(inserter))
	end
end

--error(table.concat(log,"\n----\n"))